/*   OOP   Homework 2        Beycan Kahraman   040020337   */

/*** LIBRARIES *********************************************/
#include <iostream>
using namespace std;

/*** CLASSES ***********************************************/
/*-- COUNTER ----------------------------------------------*/
class Counter{
    int number;
    public:
        Counter(int);               // consructor
        void Set(int);              // sets given values
        void operator++();          // increases number
        void operator--();          // decreases number
        bool operator>(Counter &);  // compares numbers
        int Value() const;          // returns the value
};
Counter::Counter(int initial = 0){
    number = initial;
}    
void Counter::Set(int value){
    number = value;
}
void Counter::operator++(){
    number++;
}
void Counter::operator--(){
    number--;
}
bool Counter::operator>(Counter &counter2){
    if(number > counter2.number)
        return true;
    return false;
}
int Counter::Value() const{
    return number;
}    
/*-- ModN_Counter -----------------------------------------*/
class ModN_Counter : public Counter{
    int mod;
    public:
        ModN_Counter(int modN, int num = 0):
            Counter(num)
            {
            if(modN < 1)
                mod = 1;
            else
                mod = modN;
            if(num >= mod)
                Set(mod-1);
        };
        bool operator++();        // increasing modN_Counter
        bool operator--();        // decreasing modN_Counter
};
bool ModN_Counter::operator++(){
    if(Value() == mod - 1){
        Set(0);
        return true;
    }else
        Counter::operator++();
    return false;
}
bool ModN_Counter::operator--(){
    if(Value() == 0){
        Set(mod - 1);
        return true;
    }else
        Counter::operator--();
    return false;
}
/*-- TimeOfDay --------------------------------------------*/
class TimeOfDay{
    ModN_Counter Hour;
    ModN_Counter Minute;
    ModN_Counter Second;
    public:
        TimeOfDay(int H = 0, int M = 0, int S = 0):  // constructor
            Hour(24, H), Minute(60, M), Second(60, S)
        {}
        void incS();         // increases seconds
        void incM();         // increases minutes
        void incH();         // increases hours
        int getS() const;    // returns second value
        int getM() const;    // returns minute value
        int getH() const;    // returns hour value
        bool operator>(TimeOfDay &);  // compares times
};
void TimeOfDay::incS(){
    if(++Second)
        if(++Minute)
            if(++Hour);
}
void TimeOfDay::incM(){
    if(++Minute)
        if(++Hour);
}
void TimeOfDay::incH(){
    if(++Hour);
}
int TimeOfDay::getS() const{
    return Second.Value();
}    
int TimeOfDay::getM() const{
    return Minute.Value();
} 
int TimeOfDay::getH() const{
    return Hour.Value();
} 
bool TimeOfDay::operator>(TimeOfDay &time2){
    if(Hour > time2.Hour)
        return true;
    return false;
}

/*** MAIN PROGRAM ******************************************/
int main(void){
    TimeOfDay time1(7, 45, 3);
    TimeOfDay time2, time4;
    TimeOfDay time3 = time1;
    time2.incS();
    time2.incM();
    time2.incH();
    time4 = time2;
    if(time3 > time2) 
        cout << "time3 is greater (later) than time2" << endl;
    else
        cout << "time3 is smaller (earlier) than time2" << endl;
    cout << "Time3= Hour:" << time3.getH() << " Minute:" << time3.getM() << endl;
    return 1;
}

